# Copyright (C) 2021  Topview Optronics Inc.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Android makefile for audio kernel modules

# Assume no targets will be supported

MOTORIZED_CHIPSET := motorized_lens
# Build/Package only in case of supported target

MOTORIZED_LENS_SELECT  := CONFIG_TV_PT5111=m

LOCAL_PATH := $(call my-dir)

MOTORIZED_LENS_BLD_DIR := $(ANDROID_BUILD_TOP)/vendor/topview/kernel

DLKM_DIR := $(TOP)/device/qcom/common/dlkm

# Build pt5111.ko as $(MOTORIZED_CHIPSET)_pt5111.ko
###########################################################
# This is set once per LOCAL_PATH, not per (kernel) module
KBUILD_OPTIONS := MOTORIZED_LENS_ROOT=$(MOTORIZED_LENS_BLD_DIR)

# We are actually building motorized_lens.ko here, as per the
# requirement we are specifying <chipset>_motorized_lens.ko as LOCAL_MODULE.
# This means we need to rename the module to <chipset>_motorized_lens.ko
# after motorized_lens.ko is built.
KBUILD_OPTIONS += MODNAME=pt5111
KBUILD_OPTIONS += BOARD_PLATFORM=$(TARGET_BOARD_PLATFORM)
KBUILD_OPTIONS += $(MOTORIZED_LENS_SELECT)
ifeq ($(PROJ_C258_DOME),yes)
KBUILD_OPTIONS += MODE_TYPE=_MECHANISM_DOME_
else
ifeq ($(PROJ_C258_BULLET),yes)
KBUILD_OPTIONS += MODE_TYPE=_MECHANISM_BULLET_
else
endif
endif
###########################################################
include $(CLEAR_VARS)
LOCAL_MODULE              := pt5111.ko
LOCAL_MODULE_KBUILD_NAME  := pt5111_dlkm.ko
LOCAL_MODULE_TAGS         := optional
LOCAL_MODULE_DEBUG_ENABLE := true
LOCAL_MODULE_PATH         := $(KERNEL_MODULES_OUT)
include $(DLKM_DIR)/AndroidKernelModule.mk
###########################################################
###########################################################
