/*
 * Copyright (C) 2021  Topview Optronics Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef __LENS_GPIO_H__
#define __LENS_GPIO_H__

#include <linux/interrupt.h>

enum trigger_mode {
  TRIGGER_DUAL_EDGE,
  TRIGGER_UP_EDGE,
  TRIGGER_DOWN_EDGE,
  TRIGGER_HIGH_LEVEL,
  TRIGGER_LOW_LEVEL
};

enum gpio_direction {
  GPIO_INPUT,
  GPIO_OUTPUT
};

extern void initial_gpio(u32* gpio_channels, u32 size);
void setup_gpio_direction(int gpio_id, u32 direction);
u32 read_gpio(int gpio_id);
void set_gpio(int gpio_id);
void clear_gpio(int gpio_id);
void free_gpio(int gpio_id);

/* interrupt function */
extern void setup_gpio_interrupt(int gpio_id,
    u32 trigger_mode, irq_handler_t thread_fn);
extern void enable_gpio_interrupt(int gpio_id);
extern void disable_gpio_interrupt(int gpio_id);

#endif /* __LENS_GPIO_H__ */

