/*
 * Copyright (C) 2021  Topview Optronics Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <linux/module.h>
#include <linux/string.h>
#include "lens_motor.h"

extern struct motor_driver pt5111;

s32 open_motor_driver(void *ptr, struct motor_driver* motor, u32 type) {
	s32 result = 0;

	switch (type) {
		case MOTOR_DRIVER_PT5111: 
			/* setup SPI for PT5111 */
			if (pt5111.initialize(NULL) == 0) {
				memcpy(motor, &pt5111, sizeof(struct motor_driver));
			} else {
				result = -1;
			}
			break;
		default:
			result = -1;
			break;
	}

	return result;
}

